<?php

namespace App\Controller;

use App\Entities\Ingredient;
use App\Repositories\IngredientRepository;
use App\Service\IngredientService;

class IngredientController {
    private IngredientRepository $ingredientRepository;
    private $ingredientService;

    public function __construct() {
        $this->ingredientRepository = new IngredientRepository();
        $this->ingredientService = new IngredientService();
    }

    public function getByPizza(int $idPizza):array {
        header('Content-Type: application/json');
        return $this->ingredientRepository->getIngredientsForPizza($idPizza);
    }

    public function create(mixed $data, int $idPizza):array
    {
        $ingredient = $this->ingredientService->create($data);

        if(null !== $ingredient){
            $ingredientId = $this->ingredientRepository->createIngredient($ingredient,$idPizza);
            return ["id" => $ingredientId];
        } else {
            return ["error" => "Impossible de créer l'ingrédient. Les données sont incomplètes."];
        }
    }

    public function update(array $data): array
    {
        $ingredient = $this->ingredientService->update($data);

       if(null !== $ingredient){
            $result = $this->ingredientRepository->updateIngredient($ingredient);
            if ($result) {
                return ["message" => "Ingrédient mis à jour avec succès."];
            } else {
                return ["error" => "L'ingrédient n'a pas été trouvé."];
            }
        } else {
            return ["error" => "Impossible de mettre à jour l'ingrédient. Les données sont incomplètes."];
        }
    }
}
?>