<?php

namespace App\Repositories;

use App\Entities\Category;
use PDO;

class CategoryRepository extends Repository {

    public function getCategoryById($id) {
        $query = "SELECT id, name FROM Category WHERE id = :id";
        $statement = $this->getPdo()->prepare($query);
        $statement->execute(['id' => $id]);

        $row = $statement->fetch(PDO::FETCH_ASSOC);

        return new Category($row['id'],$row['name']);;
    }

    public function getAllCategory()
    {
        $query = "SELECT id, name FROM Category";
        $statement = $this->getPdo()->query($query);
        $categorys = [];
        while ($row = $statement->fetch(PDO::FETCH_ASSOC)) {
            $category = new Category($row['id'],$row['name']);
            $categorys[] = $category;
        }
        return $categorys;
    }
}

?>
